----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2021/12/10 23:17:45
-- Design Name: 
-- Module Name: layer_0 - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:wځ@3NbN : Z̏_폜Ȃ
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity calc_layer is
    generic (
        in_int : integer;
        in_dec : integer;
        w_int : integer;
        w_dec : integer
    );
    Port (
    --input--
        clk : in STD_LOGIC;
        layer_data : in signed((in_int+in_dec)*9 -1 downto 0); --(1,6,10):17bit--
        layer_w : in signed((w_int+w_dec)*9 -1 downto 0); --(1,6,10)--
    --output--
        layer_out : out signed((in_int+in_dec) -1 downto 0) --(1,6,10):o17bit--
    );
end calc_layer;

architecture Behavioral of calc_layer is

    --3f[^̐ϘaZ--
    component mul_add_3uni
        generic (
            in_int : integer;--p[^:7bit
            in_dec : integer;--p[^:10bit
            w_int : integer;--p[^:7bit
            w_dec : integer --p[^:10bit
        );
        Port (
        --input--
             clk : in STD_LOGIC;
             data_0 : in signed(in_int+in_dec-1 downto 0);
             data_1 : in signed(in_int+in_dec-1 downto 0);
             data_2 : in signed(in_int+in_dec-1 downto 0);
             w_0 : in signed(w_int+w_dec-1 downto 0);
             w_1 : in signed(w_int+w_dec-1 downto 0);
             w_2 : in signed(w_int+w_dec-1 downto 0);
        --output--
             mul_add : out signed((in_int+in_dec)+(w_int+w_dec) - 1 downto 0)
        );
    end component;
    
    --3f[^Z--
    component add_3_data
            generic (
                data_len : integer
            );
            Port (
            --input--
                clk : in STD_LOGIC;
                data_0 : in signed(data_len -1 downto 0);
                data_1 : in signed(data_len -1 downto 0);
                data_2 : in signed(data_len -1 downto 0);
            --output--
                add_out : out signed(data_len -1 downto 0)
            );
    end component;
    
    constant data_len : integer := in_int+in_dec;
    constant w_len : integer := w_int+w_dec;
    --M--
    --f[^--
    signal data_00, data_01, data_02 : signed(data_len -1 downto 0) := (others => '0');
    signal data_10, data_11, data_12 : signed(data_len -1 downto 0) := (others => '0');
    signal data_20, data_21, data_22 : signed(data_len -1 downto 0) := (others => '0');
    --d--
    signal w_00, w_01, w_02 : signed(w_len -1 downto 0) := (others => '0');
    signal w_10, w_11, w_12 : signed(w_len -1 downto 0) := (others => '0');
    signal w_20, w_21, w_22 : signed(w_len -1 downto 0) := (others => '0');
    --Ϙa--
    signal mul_0, mul_1, mul_2 : signed(data_len+w_len -1 downto 0) := (others => '0');
    signal add_out : signed(data_len+w_len -1 downto 0) := (others => '0');
    
begin
    --f[^--
    --f[^--
    data_00 <= layer_data(data_len*9 -1 downto data_len*8);
    data_01 <= layer_data(data_len*8 -1 downto data_len*7);
    data_02 <= layer_data(data_len*7 -1 downto data_len*6);
    data_10 <= layer_data(data_len*6 -1 downto data_len*5);
    data_11 <= layer_data(data_len*5 -1 downto data_len*4);
    data_12 <= layer_data(data_len*4 -1 downto data_len*3);
    data_20 <= layer_data(data_len*3 -1 downto data_len*2);
    data_21 <= layer_data(data_len*2 -1 downto data_len*1);
    data_22 <= layer_data(data_len*1 -1 downto data_len*0);
    --d--
    w_00 <= layer_w(w_len*9 -1 downto w_len*8);
    w_01 <= layer_w(w_len*8 -1 downto w_len*7);
    w_02 <= layer_w(w_len*7 -1 downto w_len*6);
    w_10 <= layer_w(w_len*6 -1 downto w_len*5);
    w_11 <= layer_w(w_len*5 -1 downto w_len*4);
    w_12 <= layer_w(w_len*4 -1 downto w_len*3);
    w_20 <= layer_w(w_len*3 -1 downto w_len*2);
    w_21 <= layer_w(w_len*2 -1 downto w_len*1);
    w_22 <= layer_w(w_len*1 -1 downto w_len*0);
    
    
    --1s--
    line_0 : mul_add_3uni
        generic map (
            in_int => in_int,
            in_dec => in_dec,
            w_int => w_int,
            w_dec => w_dec
        )
        port map (
        --input--
        clk => clk,
        data_0 => data_00,
        data_1 => data_01,
        data_2 => data_02,
        w_0 => w_00,
        w_1 => w_01,
        w_2 => w_02,
        --output--
        mul_add => mul_0--(1,15,32)--
        );
        
    --2s--
    line_1 : mul_add_3uni
        generic map (
            in_int => in_int,
            in_dec => in_dec,
            w_int => w_int,
            w_dec => w_dec
        )
        port map (
        --input--
        clk => clk,
        data_0 => data_10,
        data_1 => data_11,
        data_2 => data_12,
        w_0 => w_10,
        w_1 => w_11,
        w_2 => w_12,
        --output--
        mul_add => mul_1
        );
        
    --3s--
    line_2 : mul_add_3uni
        generic map (
            in_int => in_int,
            in_dec => in_dec,
            w_int => w_int,
            w_dec => w_dec
        )
        port map (
        --input--
        clk => clk,
        data_0 => data_20,
        data_1 => data_21,
        data_2 => data_22,
        w_0 => w_20,
        w_1 => w_21,
        w_2 => w_22,
        --output--
        mul_add => mul_2
        );
        
    --1wډZ--
    out_layer_1 : add_3_data
        generic map (
            data_len => data_len+w_len --(1,13,20)--
        )
        port map (
        --input--
        clk => clk,
        data_0 => mul_0, --(1,13,20)--
        data_1 => mul_1, --(1,13,20)--
        data_2 => mul_2, --(1,13,20)--
        --output--
        add_out => add_out --(1,13,20)--
        );
    
    --폜--
    layer_out <= add_out(add_out'length-w_int -1 downto w_dec); --(1,6,10)--
end Behavioral;