----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/09 16:07:10
-- Design Name: 
-- Module Name: compare_dual_value - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity compare_dual_value is
    generic (
        data_len : integer
    );
    Port (
    --input--
        clk : in STD_LOGIC;
        data_1_num : in unsigned(3 downto 0);
        data_2_num : in unsigned(3 downto 0);
        data_1 : in signed(data_len -1 downto 0);
        data_2 : in signed(data_len -1 downto 0);
    --output--
        data_out_num : out unsigned(3 downto 0);
        data_out : out signed(data_len -1 downto 0)
    );
end compare_dual_value;

architecture Behavioral of compare_dual_value is

begin
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (data_1 >= data_2) then
                data_out_num <= data_1_num;
                data_out <= data_1;
            elsif (data_1 < data_2) then          
                data_out_num <= data_2_num;
                data_out <= data_2;
            end if;
        end if;
    end process;

end Behavioral;
