----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/09 16:20:19
-- Design Name: 
-- Module Name: compare_q_value - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity compare_q_value is
    generic (
        data_len : integer
    );
    Port (
    --input--
        clk : in STD_LOGIC;
        sig_in : in std_logic;
        in_data : in signed(data_len*12 -1 downto 0);
    --output--
        move_num : out unsigned(3 downto 0)
    );
end compare_q_value;

architecture Behavioral of compare_q_value is

    component compare_dual_value
        generic (
            data_len : integer
        );
        Port (
        --input--
            clk : in STD_LOGIC;
            data_1_num : in unsigned(3 downto 0);
            data_2_num : in unsigned(3 downto 0);
            data_1 : in signed(data_len -1 downto 0);
            data_2 : in signed(data_len -1 downto 0);
        --output--
            data_out_num : out unsigned(3 downto 0);
            data_out : out signed(data_len -1 downto 0)
        );
    end component;
    
    --internal signal--
    type data_array is array(0 to 11) of signed(data_len -1 downto 0);
    signal data_temp : data_array := (others => (others => '0'));
    signal data_out_temp : data_array := (others => (others => '0'));--0~5:compare1,6~8:compare2,9:compare3,10:delay for compare4,11:compare4
    type data_num_array is array(0 to 11) of unsigned(3 downto 0);
    signal data_num_out : data_num_array := (others => (others => '0'));--0~5:compare1,6~8:compare2,9:compare3,10:delay for compare4,11:compare4
    signal delay_sig_in : unsigned(4 downto 0) := (others => '0');
begin
    --in_data:divide--
    data_temp(0) <= in_data(in_data'length-data_len*0 -1 downto in_data'length-data_len*1);
    data_temp(1) <= in_data(in_data'length-data_len*1 -1 downto in_data'length-data_len*2);
    data_temp(2) <= in_data(in_data'length-data_len*2 -1 downto in_data'length-data_len*3);
    data_temp(3) <= in_data(in_data'length-data_len*3 -1 downto in_data'length-data_len*4);
    data_temp(4) <= in_data(in_data'length-data_len*4 -1 downto in_data'length-data_len*5);
    data_temp(5) <= in_data(in_data'length-data_len*5 -1 downto in_data'length-data_len*6);
    data_temp(6) <= in_data(in_data'length-data_len*6 -1 downto in_data'length-data_len*7);
    data_temp(7) <= in_data(in_data'length-data_len*7 -1 downto in_data'length-data_len*8);
    data_temp(8) <= in_data(in_data'length-data_len*8 -1 downto in_data'length-data_len*9);
    data_temp(9) <= in_data(in_data'length-data_len*9 -1 downto in_data'length-data_len*10);
    data_temp(10) <= in_data(in_data'length-data_len*10 -1 downto in_data'length-data_len*11);
    data_temp(11) <= in_data(in_data'length-data_len*11 -1 downto in_data'length-data_len*12);
    
    --r:1--
    comparetor_1 : for num in 0 to 5 generate
    comparetor : compare_dual_value
        generic map (
            data_len =>data_len
        )
        port map (
        --input--
            clk => clk,
            data_1_num => to_unsigned(2*num+1, 4),
            data_2_num => to_unsigned(2*num+2, 4),
            data_1 => data_temp(2*num),
            data_2 => data_temp(2*num+1),
        --output--
            data_out_num => data_num_out(num),
            data_out => data_out_temp(num)
        );
    end generate comparetor_1;

    --r:2--
    comparetor_2 : for num in 0 to 2 generate
    comparetor : compare_dual_value
        generic map (
            data_len =>data_len
        )
        port map (
        --input--
            clk => clk,
            data_1_num => data_num_out(2*num),
            data_2_num => data_num_out(2*num+1),
            data_1 => data_out_temp(2*num),
            data_2 => data_out_temp(2*num+1),
        --output--
            data_out_num => data_num_out(num+6),
            data_out => data_out_temp(num+6)
        );
    end generate comparetor_2;

    --r:3--
    comparetor_3 : compare_dual_value
        generic map (
            data_len =>data_len
        )
        port map (
        --input--
            clk => clk,
            data_1_num => data_num_out(6),
            data_2_num => data_num_out(7),
            data_1 => data_out_temp(6),
            data_2 => data_out_temp(7),
        --output--
            data_out_num => data_num_out(9),
            data_out => data_out_temp(9)
        );
    
    --r:4--
    comparetor_4 : compare_dual_value
        generic map (
            data_len =>data_len
        )
        port map (
        --input--
            clk => clk,
            data_1_num => data_num_out(9),
            data_2_num => data_num_out(10),
            data_1 => data_out_temp(9),
            data_2 => data_out_temp(10),
        --output--
            data_out_num => data_num_out(11),
            data_out => data_out_temp(11)
        );
    
    --function--
    --data_num out timing--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (delay_sig_in(4) = '1') then
                move_num <= data_num_out(11);
            else
                move_num <= (others => '0');
            end if;
        end if;
    end process;
    --DFF--
    process(clk)
    begin
        if (clk'event and clk='1') then
        --for compare4--
            data_num_out(10) <= data_num_out(8);
            data_out_temp(10) <= data_out_temp(8);
        --for data_num out--
            delay_sig_in(0) <= sig_in;
            for i in 0 to 3 loop
                delay_sig_in(i+1) <= delay_sig_in(i);
            end loop;
        end if;
    end process;
    
end Behavioral;
