----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/14 17:34:20
-- Design Name: 
-- Module Name: conv_layer_2_karnel_addr_re - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity conv_layer_2_karnel_addr_re is
    Port (
    --input--
        clk : in STD_LOGIC;
        reset : in std_logic;
        count : in unsigned(11 downto 0);
    --output--
        sig_36_data_out : out std_logic;
        sig_uni_karnel_out : out std_logic;
--        count36 : out unsigned(5 downto 0);
        addr : out unsigned(9 downto 0) --960<1024=2^10;
    );
end conv_layer_2_karnel_addr_re;

architecture Behavioral of conv_layer_2_karnel_addr_re is

    constant addr_bit : integer := 10;
    
    signal count_8 : unsigned(2 downto 0) := (others => '0');
    signal count_12 : unsigned(3 downto 0) := (others => '0');
    signal count_36 : unsigned(5 downto 0) := (others => '0');
    signal calc_num : unsigned(addr_bit -1 downto 0) := (others => '0');
    signal temp_1 : unsigned(addr_bit -1 downto 0) := (others => '0');
    signal count_karnel_out : unsigned(2 downto 0) := (others => '0');
    signal sig_36_data_out_temp : std_logic := '0';
    signal mul_for_temp_1 : unsigned(addr_bit -1 downto 0) := (others => '0');
begin
    --count_36--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset = '1') then
                count_36 <= (others => '0');
            else
                count_36 <= to_unsigned(to_integer(count)-36*to_integer(count_8)-36*8*to_integer(count_12), count_36'length);
            end if;
        end if;
    end process;
--    count36 <= count_36;
    
    --count_8--
    process(count_36)
    begin
        if (reset = '1') then
            count_8 <= (others => '0');
        else
            if (to_integer(count_36) = 35) then
                count_8 <= count_8 + to_unsigned(1, count_8'length);
            end if;
        end if;
    end process;
    
    --count_12--
    process(count_36)
    begin
        if (reset = '1') then
            count_12 <= (others => '0');
        else
            if (to_integer(count_12) = 11 and to_integer(count_36) = 35 and to_integer(count_8) = 7) then
                count_12 <= (others => '0');
            elsif (to_integer(count_36) = 35 and to_integer(count_8) = 7) then
                count_12 <= count_12 + to_unsigned(1, count_12'length);
            end if;
        end if;
    end process;
    
    --conv count_12 to karnel bias--
    process(count_12)
    begin
        case to_integer(count_12) is
            --line_0--
            when 0 => calc_num <= to_unsigned(0, addr_bit);
            when 1 => calc_num <= to_unsigned(1, addr_bit);
            when 2 => calc_num <= to_unsigned(2, addr_bit);
            when 3 => calc_num <= to_unsigned(3, addr_bit);
            --line_1--
            when 4 => calc_num <= to_unsigned(6, addr_bit);
            when 5 => calc_num <= to_unsigned(7, addr_bit);
            when 6 => calc_num <= to_unsigned(8, addr_bit);
            when 7 => calc_num <= to_unsigned(9, addr_bit);
            --line_2--
            when 8 => calc_num <= to_unsigned(12, addr_bit);
            when 9 => calc_num <= to_unsigned(13, addr_bit);
            when 10 => calc_num <= to_unsigned(14, addr_bit);
            when 11 => calc_num <= to_unsigned(15, addr_bit);
            when others => null;
        end case;
    end process;
    
    
    mul_for_temp_1 <= to_unsigned(to_integer(count_8)*120, addr_bit);
    --gen addr--
    process(count_36)
    begin
        case (to_integer(count_36)) is
            --layer_0--
            --line_0--
            when 0 => temp_1 <= to_unsigned(0, addr_bit) + mul_for_temp_1 + calc_num;
            when 1 => temp_1 <= to_unsigned(1, addr_bit) + mul_for_temp_1 + calc_num;
            when 2 => temp_1 <= to_unsigned(2, addr_bit) + mul_for_temp_1 + calc_num;
            --line_1--
            when 3 => temp_1 <= to_unsigned(6, addr_bit) + mul_for_temp_1 + calc_num;
            when 4 => temp_1 <= to_unsigned(7, addr_bit) + mul_for_temp_1 + calc_num;
            when 5 => temp_1 <= to_unsigned(8, addr_bit) + mul_for_temp_1 + calc_num;
            --line_2--
            when 6 => temp_1 <= to_unsigned(12, addr_bit) + mul_for_temp_1 + calc_num;
            when 7 => temp_1 <= to_unsigned(13, addr_bit) + mul_for_temp_1 + calc_num;
            when 8 => temp_1 <= to_unsigned(14, addr_bit) + mul_for_temp_1 + calc_num;
            --layer_1:+30--
            --line_0--
            when 9 => temp_1 <= to_unsigned(30, addr_bit) + mul_for_temp_1 + calc_num;
            when 10 => temp_1 <= to_unsigned(31, addr_bit) + mul_for_temp_1 + calc_num;
            when 11 => temp_1 <= to_unsigned(32, addr_bit) + mul_for_temp_1 + calc_num;
            --line_1--
            when 12 => temp_1 <= to_unsigned(36, addr_bit) + mul_for_temp_1 + calc_num;
            when 13 => temp_1 <= to_unsigned(37, addr_bit) + mul_for_temp_1 + calc_num;
            when 14 => temp_1 <= to_unsigned(38, addr_bit) + mul_for_temp_1 + calc_num;
            --line_2--
            when 15 => temp_1 <= to_unsigned(42, addr_bit) + mul_for_temp_1 + calc_num;
            when 16 => temp_1 <= to_unsigned(43, addr_bit) + mul_for_temp_1 + calc_num;
            when 17 => temp_1 <= to_unsigned(44, addr_bit) + mul_for_temp_1 + calc_num;
            --layer_2:+60--
            --line_0--
            when 18 => temp_1 <= to_unsigned(60, addr_bit) + mul_for_temp_1 + calc_num;
            when 19 => temp_1 <= to_unsigned(61, addr_bit) + mul_for_temp_1 + calc_num;
            when 20 => temp_1 <= to_unsigned(62, addr_bit) + mul_for_temp_1 + calc_num;
            --line_1--
            when 21 => temp_1 <= to_unsigned(66, addr_bit) + mul_for_temp_1 + calc_num;
            when 22 => temp_1 <= to_unsigned(67, addr_bit) + mul_for_temp_1 + calc_num;
            when 23 => temp_1 <= to_unsigned(68, addr_bit) + mul_for_temp_1 + calc_num;
            --line_2--
            when 24 => temp_1 <= to_unsigned(72, addr_bit) + mul_for_temp_1 + calc_num;
            when 25 => temp_1 <= to_unsigned(73, addr_bit) + mul_for_temp_1 + calc_num;
            when 26 => temp_1 <= to_unsigned(74, addr_bit) + mul_for_temp_1 + calc_num;
            --layer_3:+90--
            --line_0--
            when 27 => temp_1 <= to_unsigned(90, addr_bit) + mul_for_temp_1 + calc_num;
            when 28 => temp_1 <= to_unsigned(91, addr_bit) + mul_for_temp_1 + calc_num;
            when 29 => temp_1 <= to_unsigned(92, addr_bit) + mul_for_temp_1 + calc_num;
            --line_1--
            when 30 => temp_1 <= to_unsigned(96, addr_bit) + mul_for_temp_1 + calc_num;
            when 31 => temp_1 <= to_unsigned(97, addr_bit) + mul_for_temp_1 + calc_num;
            when 32 => temp_1 <= to_unsigned(98, addr_bit) + mul_for_temp_1 + calc_num;
            --line_2--
            when 33 => temp_1 <= to_unsigned(102, addr_bit) + mul_for_temp_1 + calc_num;
            when 34 => temp_1 <= to_unsigned(103, addr_bit) + mul_for_temp_1 + calc_num;
            when 35 => temp_1 <= to_unsigned(104, addr_bit) + mul_for_temp_1 + calc_num;
            when others => null;
        end case;
    end process;
    
    --36f[^ǂݏoM--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset = '1') then
                sig_36_data_out_temp <= '0';
            else
                if (to_integer(count) < 3459) then
                    if (to_integer(count_36) = 35) then
                        sig_36_data_out_temp <= '1';
                    else
                        sig_36_data_out_temp <= '0';
                    end if;
                else
                    sig_36_data_out_temp <= '0';
                end if;
            end if;
        end if;
    end process;
    sig_36_data_out <= sig_36_data_out_temp;
    
    --1karnelǂݏoM--
    --sig_36_data_out_temp𐔂8iJE^--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset = '1') then
                count_karnel_out <= (others => '0');
            else
                if (sig_36_data_out_temp = '1') then
                    count_karnel_out <= count_karnel_out + to_unsigned(1, count_karnel_out'length);
                end if;
            end if;
        end if;
    end process;
    
    --sig_uni_karnel_out̏o--
    process(count_karnel_out, sig_36_data_out_temp)
    begin
        if (reset = '1') then
            sig_uni_karnel_out <= '0';
        else
            if (to_integer(count_karnel_out) = 7 and sig_36_data_out_temp = '1') then
                sig_uni_karnel_out <= '1';
            else
                sig_uni_karnel_out <= '0';
            end if;
        end if;
    end process;
    
    addr <= temp_1;

end Behavioral;