----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/16 11:52:58
-- Design Name: 
-- Module Name: conv_layer_affine_read_addr_re - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity conv_layer_affine_read_addr_re is
    Port (
    --input--
        clk : in std_logic;
        reset : in std_logic;
        count : in unsigned(7 downto 0);
    --output--
        sig_36_data_out : out std_logic;
        sig_uni_data_out : out std_logic := '0';
        addr : out unsigned(7 downto 0) --192<256=2^8;
    );
end conv_layer_affine_read_addr_re;

architecture Behavioral of conv_layer_affine_read_addr_re is
    constant addr_bit : integer := 7;
    
    signal count_6 : unsigned(2 downto 0) := (others => '0');
    signal count_36 : unsigned(5 downto 0) := (others => '0');
    signal calc_num : unsigned(addr_bit -1 downto 0) := (others => '0');
    signal temp_1 : unsigned(addr_bit -1 downto 0) := (others => '0');
    signal count_karnel_out : unsigned(2 downto 0) := (others => '0');
    signal sig_36_data_out_temp : std_logic := '0';
begin
    --count_36--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset = '1') then
                count_36 <= (others => '0');
            else
                if (to_integer(count) > 191) then
                    count_36 <= (others => '0');
                else
                    count_36 <= to_unsigned(to_integer(count)-36*to_integer(count_6), count_36'length);
                end if;
            end if;
        end if;
    end process;
    
    --count_6--
    process(count_36,reset)
    begin
        if (reset = '1') then
            count_6 <= (others => '0');
        else
            if (to_integer(count_36) = 35) then
                count_6 <= count_6 + to_unsigned(1, count_6'length);
            end if;
        end if;
    end process;
        
    --sig_36_data_out--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (to_integer(count_36) = 35) then
                sig_36_data_out <= '1';
            else
                sig_36_data_out <= '0';
            end if;
        end if;
    end process;
    
    --sig_uni_data_out--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (to_integer(count) = 192) then
                sig_uni_data_out <= '1';
            else
                sig_uni_data_out <= '0';
            end if;
        end if;
    end process;
    
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (to_integer(count) < 192) then
                addr <= count;
            else
                addr <= (others => '0');
            end if;
        end if;
    end process;
    
end Behavioral;
