----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/14 17:18:42
-- Design Name: 
-- Module Name: conv_padding_addr_layer2_re - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity conv_padding_addr_layer2_re is
    Port (
    --input--
        clk : in STD_LOGIC;
        reset : in std_logic;
        sig_calc_end : in std_logic; 
    --output--
        ram_wea : out std_logic := '0';
        addr : out unsigned(9 downto 0)
    );
end conv_padding_addr_layer2_re;

architecture Behavioral of conv_padding_addr_layer2_re is

    --intenal signal--
    signal count36 : unsigned(5 downto 0) := (others => '0');
    signal count12 : unsigned(4 downto 0) := (others => '0');
    signal sig_pad_layer2_end : std_logic := '0';
    signal mul_for_addr : integer := 0;
begin
    --count36--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (sig_calc_end = '1' or sig_pad_layer2_end = '1') then
                count36 <= (others => '0');
            else
                count36 <= count36 + to_unsigned(1, count36'length);
            end if;
        end if;
    end process;
    
    --count12--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset='1' or sig_pad_layer2_end = '1') then
                count12 <= (others => '0');
            elsif (sig_calc_end='1') then
                count12 <= count12 + to_unsigned(1, count12'length);
            end if;
        end if;
    end process;
    
    --signal padding end--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset = '1') then
                sig_pad_layer2_end <= '0';
            elsif(to_integer(count36) = 35 and to_integer(count12) = 12) then
                sig_pad_layer2_end <= '1';
            end if;
        end if;
    end process;
    
    --reduce_dsp--
    process(clk)
    begin
        if (to_integer(count36) >= 31) then--reset_timing : 1clkx̂count288+1邩31ȏ̂Ƃ0
            mul_for_addr <= 0;
        else
            mul_for_addr <= (to_integer(count36)+1)*30;--
        end if;
    end process;
    
    --conv_padding_addr: layer_2--
    process(count36)
    begin
        if (to_integer(count36) < 32) then
            case to_integer(count12)-1 is
                when 0 => addr <= to_unsigned(mul_for_addr+7, addr'length);
                when 1 => addr <= to_unsigned(mul_for_addr+8, addr'length);
                when 2 => addr <= to_unsigned(mul_for_addr+9, addr'length);
                when 3 => addr <= to_unsigned(mul_for_addr+10, addr'length);
                when 4 => addr <= to_unsigned(mul_for_addr+13, addr'length);
                when 5 => addr <= to_unsigned(mul_for_addr+14, addr'length);
                when 6 => addr <= to_unsigned(mul_for_addr+15, addr'length);
                when 7 => addr <= to_unsigned(mul_for_addr+16, addr'length);
                when 8 => addr <= to_unsigned(mul_for_addr+19, addr'length);
                when 9 => addr <= to_unsigned(mul_for_addr+20, addr'length);
                when 10 => addr <= to_unsigned(mul_for_addr+21, addr'length);
                when 11 => addr <= to_unsigned(mul_for_addr+22, addr'length);
                when 15 => addr <= (others => '0');
                when others => null;
            end case;
        end if;
    end process;
    
    --generate ram_ena--
    process(count36)
    begin
        if (reset = '1') then
            ram_wea <= '0';
        elsif (to_integer(count36) > 31) then
            ram_wea <= '0';
        else
            if (to_integer(count12)  = 12 and to_integer(count36) = 35) then
                ram_wea <= '0';
            elsif (to_integer(count12) > 0) then
                ram_wea <= '1';
            end if;
        end if;
    end process;



end Behavioral;