----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/16 10:39:16
-- Design Name: 
-- Module Name: conv_padding_addr_layer3_re - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity conv_padding_addr_layer3_re is
    Port (
    --input--
        clk : in STD_LOGIC;
        reset : in std_logic;
        sig_calc_out : in std_logic;
    --output--
        ram_wea : out std_logic;
        addr : out unsigned(9 downto 0)
    );
end conv_padding_addr_layer3_re;

architecture Behavioral of conv_padding_addr_layer3_re is

    signal count288 : unsigned(8 downto 0) := (others => '0');
    signal count12 : unsigned(3 downto 0) := ( others => '0');
    signal mul_for_addr : integer := 0;
begin

    --count288--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset = '1' or sig_calc_out = '1') then
                count288 <= (others => '0');
            else
                count288 <= count288 + to_unsigned(1, count288'length);
            end if;
        end if;
    end process;
    
    --count12--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset='1') then
                count12 <= (others => '0');
            elsif (sig_calc_out='1') then
                count12 <= count12 + to_unsigned(1, count12'length);
            end if;
        end if;
    end process;
    
    --reduce_dsp--
    process(clk)
    begin
        if (to_integer(count288) >= 31) then--reset_timing : 1clkx̂count288+1邩31ȏ̂Ƃ0
            mul_for_addr <= 0;
        else
            mul_for_addr <= (to_integer(count288)+1)*30;--
        end if;
    end process;
    
    --conv_padding_addr: layer_3--
    process(count288)
    begin
        if (to_integer(count288) < 32) then
            case to_integer(count12)-1 is
                when 0 => addr <= to_unsigned(mul_for_addr+7, addr'length);
                when 1 => addr <= to_unsigned(mul_for_addr+8, addr'length);
                when 2 => addr <= to_unsigned(mul_for_addr+9, addr'length);
                when 3 => addr <= to_unsigned(mul_for_addr+10, addr'length);
                when 4 => addr <= to_unsigned(mul_for_addr+13, addr'length);
                when 5 => addr <= to_unsigned(mul_for_addr+14, addr'length);
                when 6 => addr <= to_unsigned(mul_for_addr+15, addr'length);
                when 7 => addr <= to_unsigned(mul_for_addr+16, addr'length);
                when 8 => addr <= to_unsigned(mul_for_addr+19, addr'length);
                when 9 => addr <= to_unsigned(mul_for_addr+20, addr'length);
                when 10 => addr <= to_unsigned(mul_for_addr+21, addr'length);
                when 11 => addr <= to_unsigned(mul_for_addr+22, addr'length);
                when others => addr <= (others => '0');
            end case;
        else
            addr <= (others => '0');
        end if;
    end process;
    
    --generate ram_ena--
    process(count288)
    begin
        if (reset = '1') then
            ram_wea <= '0';
        elsif (to_integer(count288) > 31) then
            ram_wea <= '0';
        else
            if (to_integer(count12)  = 12 and to_integer(count288) = 35) then
                ram_wea <= '0';
            elsif (to_integer(count12) > 0) then
                ram_wea <= '1';
            end if;
        end if;
    end process;

end Behavioral;