----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2021/12/24 13:29:51
-- Design Name: 
-- Module Name: conv_ram_addr - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity conv_rom_and_ram_addr is
    Port (
    --input--
        clk : in STD_LOGIC;
        count : in unsigned(9 downto 0);--480<512=2^9
        count_12 : in unsigned(3 downto 0);
    --output--
        w_ram_addr : out unsigned(6 downto 0);--112<128=2^7
        calc_addr : out unsigned(6 downto 0)--120<128=2^7
    );
end conv_rom_and_ram_addr;

architecture Behavioral of conv_rom_and_ram_addr is
    --internal signal--
    constant addr_bit : integer := 7;
    signal temp_0 : unsigned(addr_bit -1 downto 0) := (others => '0');
    signal temp_1 : unsigned(addr_bit -1 downto 0) := (others => '0');
    signal calc_num : unsigned(addr_bit -1 downto 0) := (others => '0');
begin

    --w_ram_addr,calc_addr--
    w_ram_addr <= temp_0;
    calc_addr <= temp_1;
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (count < to_unsigned(48, 8)) then --w_ram_addrp--
                case to_integer(count) is --to_integerɂȂwarningo
                    --layer_0--
                    --line_0:+7--
                    when 0 => temp_0 <= to_unsigned(7, addr_bit);
                    when 1 => temp_0 <= to_unsigned(8, addr_bit);
                    when 2 => temp_0 <= to_unsigned(9, addr_bit);
                    when 3 => temp_0 <= to_unsigned(10, addr_bit);
                    --line_1:+9--
                    when 4 => temp_0 <= to_unsigned(13, addr_bit);
                    when 5 => temp_0 <= to_unsigned(14, addr_bit);
                    when 6 => temp_0 <= to_unsigned(15, addr_bit);
                    when 7 => temp_0<= to_unsigned(16, addr_bit);
                    --line_2:+11--
                    when 8 => temp_0 <= to_unsigned(19, addr_bit);
                    when 9 => temp_0 <= to_unsigned(20, addr_bit);
                    when 10 => temp_0 <= to_unsigned(21, addr_bit);
                    when 11 => temp_0 <= to_unsigned(22, addr_bit);
                    --layer_1:+30--
                    --line_0:+7--
                    when 12 => temp_0 <= to_unsigned(37, addr_bit);
                    when 13 => temp_0 <= to_unsigned(38, addr_bit);
                    when 14 => temp_0 <= to_unsigned(39, addr_bit);
                    when 15 => temp_0 <= to_unsigned(40, addr_bit);
                    --line_1:+9--
                    when 16 => temp_0 <= to_unsigned(43, addr_bit);
                    when 17 => temp_0 <= to_unsigned(44, addr_bit);
                    when 18 => temp_0 <= to_unsigned(45, addr_bit);
                    when 19 => temp_0 <= to_unsigned(46, addr_bit);
                    --line_2:+11--
                    when 20 => temp_0 <= to_unsigned(49, addr_bit);
                    when 21 => temp_0 <= to_unsigned(50, addr_bit);
                    when 22 => temp_0 <= to_unsigned(51, addr_bit);
                    when 23 => temp_0 <= to_unsigned(52, addr_bit);
                    --layer_2:+60--
                    --line_0:+7--
                    when 24 => temp_0 <= to_unsigned(67, addr_bit);
                    when 25 => temp_0 <= to_unsigned(68, addr_bit);
                    when 26 => temp_0 <= to_unsigned(69, addr_bit);
                    when 27 => temp_0 <= to_unsigned(70, addr_bit);
                    --line_1:+9--
                    when 28 => temp_0 <= to_unsigned(73, addr_bit);
                    when 29 => temp_0 <= to_unsigned(74, addr_bit);
                    when 30 => temp_0 <= to_unsigned(75, addr_bit);
                    when 31 => temp_0 <= to_unsigned(76, addr_bit);
                    --line_2:+11--
                    when 32 => temp_0 <= to_unsigned(79, addr_bit);
                    when 33 => temp_0 <= to_unsigned(80, addr_bit);
                    when 34 => temp_0 <= to_unsigned(81, addr_bit);
                    when 35 => temp_0 <= to_unsigned(82, addr_bit);
                    --layer_3:+90--
                    --line_0:+7--
                    when 36 => temp_0 <= to_unsigned(97, addr_bit);
                    when 37 => temp_0 <= to_unsigned(98, addr_bit);
                    when 38 => temp_0 <= to_unsigned(99, addr_bit);
                    when 39 => temp_0 <= to_unsigned(100, addr_bit);
                    --line_1:+9--
                    when 40 => temp_0 <= to_unsigned(103, addr_bit);
                    when 41 => temp_0 <= to_unsigned(104, addr_bit);
                    when 42 => temp_0 <= to_unsigned(105, addr_bit);
                    when 43 => temp_0 <= to_unsigned(106, addr_bit);
                    --line_2:+11--
                    when 44 => temp_0 <= to_unsigned(109, addr_bit);
                    when 45 => temp_0 <= to_unsigned(110, addr_bit);
                    when 46 => temp_0 <= to_unsigned(111, addr_bit);
                    when 47 => temp_0 <= to_unsigned(112, addr_bit);
                    when others => null;
                end case;
                
                temp_1 <= (others => '0'); --calc_addr0
            elsif (count >= to_unsigned(48, 8)) then --calc_addrp
                temp_0 <= (others => '0'); --w_ram_addr0
                
                case (to_integer(count)-48-36*to_integer(count_12)) is
                    --layer_0--
                    --line_0--
                    when 0 => temp_1 <= to_unsigned(0, addr_bit) + calc_num;
                    when 1 => temp_1 <= to_unsigned(1, addr_bit) + calc_num;
                    when 2 => temp_1 <= to_unsigned(2, addr_bit) + calc_num;
                    --line_1--
                    when 3 => temp_1 <= to_unsigned(6, addr_bit) + calc_num;
                    when 4 => temp_1 <= to_unsigned(7, addr_bit) + calc_num;
                    when 5 => temp_1 <= to_unsigned(8, addr_bit) + calc_num;
                    --line_2--
                    when 6 => temp_1 <= to_unsigned(12, addr_bit) + calc_num;
                    when 7 => temp_1 <= to_unsigned(13, addr_bit) + calc_num;
                    when 8 => temp_1 <= to_unsigned(14, addr_bit) + calc_num;
                    --layer_1:+30--
                    --line_0--
                    when 9 => temp_1 <= to_unsigned(30, addr_bit) + calc_num;
                    when 10 => temp_1 <= to_unsigned(31, addr_bit) + calc_num;
                    when 11 => temp_1 <= to_unsigned(32, addr_bit) + calc_num;
                    --line_1--
                    when 12 => temp_1 <= to_unsigned(36, addr_bit) + calc_num;
                    when 13 => temp_1 <= to_unsigned(37, addr_bit) + calc_num;
                    when 14 => temp_1 <= to_unsigned(38, addr_bit) + calc_num;
                    --line_2--
                    when 15 => temp_1 <= to_unsigned(42, addr_bit) + calc_num;
                    when 16 => temp_1 <= to_unsigned(43, addr_bit) + calc_num;
                    when 17 => temp_1 <= to_unsigned(44, addr_bit) + calc_num;
                    --layer_2:+60--
                    --line_0--
                    when 18 => temp_1 <= to_unsigned(60, addr_bit) + calc_num;
                    when 19 => temp_1 <= to_unsigned(61, addr_bit) + calc_num;
                    when 20 => temp_1 <= to_unsigned(62, addr_bit) + calc_num;
                    --line_1--
                    when 21 => temp_1 <= to_unsigned(66, addr_bit) + calc_num;
                    when 22 => temp_1 <= to_unsigned(67, addr_bit) + calc_num;
                    when 23 => temp_1 <= to_unsigned(68, addr_bit) + calc_num;
                    --line_2--
                    when 24 => temp_1 <= to_unsigned(72, addr_bit) + calc_num;
                    when 25 => temp_1 <= to_unsigned(73, addr_bit) + calc_num;
                    when 26 => temp_1 <= to_unsigned(74, addr_bit) + calc_num;
                    --layer_3:+90--
                    --line_0--
                    when 27 => temp_1 <= to_unsigned(90, addr_bit) + calc_num;
                    when 28 => temp_1 <= to_unsigned(91, addr_bit) + calc_num;
                    when 29 => temp_1 <= to_unsigned(92, addr_bit) + calc_num;
                    --line_1--
                    when 30 => temp_1 <= to_unsigned(96, addr_bit) + calc_num;
                    when 31 => temp_1 <= to_unsigned(97, addr_bit) + calc_num;
                    when 32 => temp_1 <= to_unsigned(98, addr_bit) + calc_num;
                    --line_2--
                    when 33 => temp_1 <= to_unsigned(102, addr_bit) + calc_num;
                    when 34 => temp_1 <= to_unsigned(103, addr_bit) + calc_num;
                    when 35 => temp_1 <= to_unsigned(104, addr_bit) + calc_num;
                    when others => null;
                end case;
            end if;
        end if;

    end process;
    
    process(count_12)
    begin
        case to_integer(count_12) is
            --line_0--
            when 0 => calc_num <= to_unsigned(0, addr_bit);
            when 1 => calc_num <= to_unsigned(1, addr_bit);
            when 2 => calc_num <= to_unsigned(2, addr_bit);
            when 3 => calc_num <= to_unsigned(3, addr_bit);
            --line_1--
            when 4 => calc_num <= to_unsigned(6, addr_bit);
            when 5 => calc_num <= to_unsigned(7, addr_bit);
            when 6 => calc_num <= to_unsigned(8, addr_bit);
            when 7 => calc_num <= to_unsigned(9, addr_bit);
            --line_2--
            when 8 => calc_num <= to_unsigned(12, addr_bit);
            when 9 => calc_num <= to_unsigned(13, addr_bit);
            when 10 => calc_num <= to_unsigned(14, addr_bit);
            when 11 => calc_num <= to_unsigned(15, addr_bit);
            when others => null;
        end case;
    end process;


end Behavioral;
