----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/07 18:03:06
-- Design Name: 
-- Module Name: conv_store_addr_layer4_out - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity conv_store_addr_layer4_out is
    Port (
    --input--
        clk : in STD_LOGIC;
        reset : in std_logic;
        sig_calc_out : in std_logic;
    --output--
        ram_wea_a : out std_logic;
        ram_wea_b : out std_logic;
        addr : out unsigned(7 downto 0)
    );
end conv_store_addr_layer4_out;

architecture Behavioral of conv_store_addr_layer4_out is

    signal count288 : unsigned(8 downto 0) := (others => '0');
    signal count12 : unsigned(3 downto 0) := ( others => '0');
begin

    --count288--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset = '1' or sig_calc_out = '1') then
                count288 <= (others => '0');
            else
                count288 <= count288 + to_unsigned(1, count288'length);
            end if;
        end if;
    end process;
    
    --count12--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset='1') then
                count12 <= (others => '0');
            elsif (sig_calc_out='1') then
                count12 <= count12 + to_unsigned(1, count12'length);
            end if;
        end if;
    end process;
    
    --conv_store_addr : for Affine layer--
    --[peBO--
    process(count288)
    begin
        if (to_integer(count12) > 0) then
            if (to_integer(count288) < 16) then
                addr <= to_unsigned(to_integer(count288)*12+to_integer(count12)-1, addr'length);--0~15chݗpaddr(ram a)
            elsif (to_integer(count288) < 32) then
                addr <= to_unsigned((to_integer(count288)-16)*12+to_integer(count12)-1, addr'length);--16~31chݗpaddr(ram b)
            else
                addr <= (others => '0');
            end if;
        else
            addr <= (others => '0');
        end if;
    end process;
    
    --ram wea a/b--
    process(count288)
    begin
        if (reset = '1') then
            ram_wea_a <= '0';
            ram_wea_b <= '0';
        else
            if (to_integer(count288) < 16) then
                ram_wea_a <= '1';
                ram_wea_b <= '0';
            elsif (to_integer(count288) < 32) then
                ram_wea_a <= '0';
                ram_wea_b <= '1';
            else
                ram_wea_a <= '0';
                ram_wea_b <= '0';
            end if;
        end if;
    end process;
end Behavioral;
