----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/11 00:00:06
-- Design Name: 
-- Module Name: corr_cube - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity corr_cube is
    Port (
    --input--
        clk : in STD_LOGIC;
        reset : in std_logic;
        in_data : in unsigned(99 downto 0);
    --output--
        sig_corr : out std_logic := '0';
        out_data : out unsigned(99 downto 0) := (others => '0')
    );
end corr_cube;

architecture Behavioral of corr_cube is

    --internal signal--
    function correct_data return unsigned is
        variable cube_func : unsigned(99 downto 0) := (others => '0');
    begin
        for corner_num in 0 to 7 loop
            cube_func(cube_func'length-5*corner_num -1 downto cube_func'length-5*(corner_num+1)) := to_unsigned(corner_num, 3) & "00";
        end loop;
        
        for edge_num in 0 to 11 loop
            cube_func(cube_func'length-5*(8+edge_num) -1 downto cube_func'length-5*(8+edge_num+1)) := to_unsigned(edge_num, 4) & '0';
        end loop;
        
        return cube_func;
    end function;
    
    constant corr_cube : unsigned(99 downto 0) := correct_data;
begin
    --check correct cube--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset = '1') then
                out_data <= (others => '0');
                sig_corr <= '0';
            elsif (in_data = corr_cube) then
                out_data <= (others => '0');
                sig_corr <= '1';
            else
                out_data <= in_data;
                sig_corr <= '0';
            end if;
        end if;
    end process;

end Behavioral;
