----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/03 19:04:41
-- Design Name: 
-- Module Name: counter_layer2 - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments: 3456+clock:36*8=1karnel data,*12 moving <= 4096
-- 3501clock
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity counter_layer2 is
    Port (
    --input--
        clk : in STD_LOGIC;
        reset : in std_logic;
    --output--
        count : out unsigned(11 downto 0) --3456<4096=2^12
    );
end counter_layer2;

architecture Behavioral of counter_layer2 is

    --intenal signal--
    constant count_bit : integer := 12;
    
    signal count_temp : unsigned(count_bit -1 downto 0) := (others => '0');
begin
    --3501 clock--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset ='1') then
                count_temp <= (others => '0');
            elsif (count_temp = to_unsigned(3500, count_bit)) then
                count_temp <= (others => '0');
            else
                count_temp <= count_temp + to_unsigned(1, count_bit);
            end if;
        end if;
    end process;
    
    count <= count_temp;
    
end Behavioral;
