----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/10 23:59:25
-- Design Name: 
-- Module Name: cube_model - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity cube_model is
    Port (
    --input--
        clk : in STD_LOGIC;
        reset : in std_logic;
        sig_change_cube : in std_logic;
        move_step : in unsigned(3 downto 0);
        current_cube : in unsigned(99 downto 0);
    --output--
        sig_corr_cube : out std_logic := '0';
        sig_update_cube : out std_logic := '0';
        update_cube : out unsigned(99 downto 0)
    );
end cube_model;

architecture Behavioral of cube_model is

    component cube_change
        Port (
        --input--
            clk : in STD_LOGIC;
            reset : in std_logic;
            sig_change : in std_logic;
            move_step : in unsigned(3 downto 0);
            current_cube : in unsigned(99 downto 0);
        --output--
            sig_update_cube : out std_logic;
            update_cube : out unsigned(99 downto 0)
        );
    end component;
    
    component corr_cube
        Port (
        --input--
            clk : in STD_LOGIC;
            reset : in std_logic;
            in_data : in unsigned(99 downto 0);
        --output--
            sig_corr : out std_logic := '0';
            out_data : out unsigned(99 downto 0) := (others => '0')
        );
    end component;
    
    signal cube_data_temp : unsigned(99 downto 0) := (others => '0');
    signal sig_delay_update_cube : std_logic := '0';
begin

    change : cube_change
        port map (
        --input--
            clk => clk,
            reset => reset,
            sig_change => sig_change_cube,
            move_step => move_step,
            current_cube => current_cube,
        --output--
            sig_update_cube => sig_delay_update_cube,
            update_cube => cube_data_temp
        );

    correct : corr_cube
        port map (
        --input--
            clk => clk,
            reset => reset,
            in_data => cube_data_temp,
        --output--
            sig_corr => sig_corr_cube,
            out_data => update_cube
        );
    
    --function--
    --DFF--
    process(clk)
    begin
        if (clk'event and clk='1') then
            sig_update_cube <= sig_delay_update_cube;
        end if;
    end process;
end Behavioral;
