----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2021/12/31 13:20:41
-- Design Name: 
-- Module Name: eLU_table - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;
use std.textio.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity eLU_table is
    Port (
    --input--
        clk : in STD_LOGIC;
        ena : in std_logic;
        addr : in signed(10 downto 0); --1597 < 2048=2^12
    --output--
        eLU_out : out signed(7 downto 0) --o͂͏8bit
    );
end eLU_table;

architecture Behavioral of eLU_table is
    --internal signal--
    constant eLU_table_depth : integer := 1597;
    constant rom_depth : integer := 2048;
    constant file_name : string := "eLU_table.txt";
    constant eLU_data_len : integer := 8;

    --for ram--
    type rom_type is array(0 to rom_depth -1) of signed(eLU_data_len -1 downto 0);

    --read text data and return data as rom_type--
    impure function store_eLU_table return rom_type is
        file text_file : text;
        variable text_line : line;
        variable rom_content : rom_type;
        variable line_bit : bit_vector(eLU_data_len -1 downto 0);--variableȂ̂łǂꂾmۂ邩w
    begin
        file_open(text_file, file_name, read_mode);--t@Cǂݎ胂[hŊJ
        
        for i in 0 to eLU_table_depth -1 loop --瑤ŉsǂ݂w肵Ă̂œendƂ͕KvȂ
            readline(text_file, text_line); --impureȂfileJȂ炵F1sǂ݂lineϐɂ܂
            read(text_line, line_bit); --lineϐϊ
            rom_content(i) := signed(to_stdlogicvector(line_bit));--signedɕϊ
        end loop;
        
        file_close(text_file);--t@C
    
        return rom_content;
    end function;
    
    --rom--
    signal rom_temp : rom_type := store_eLU_table;
    attribute romtype : string;
    attribute romtype of rom_temp : signal is "block";
    signal data_temp : signed(eLU_data_len -1 downto 0) := (others => '0');
    
    
begin
    process(clk)
    begin
        if (clk'event and clk='1') then
            if(ena = '1') then
                data_temp <= rom_temp(to_integer(unsigned(addr)));
            else
                data_temp <= (others => '0');
            end if;
        end if;
    end process;
    
    eLU_out <= data_temp;


end Behavioral;
