----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2021/12/24 13:28:05
-- Design Name: 
-- Module Name: gen_store_and_karnel_addr - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity gen_store_and_karnel_addr is
    Port (
    --input--
        clk : in STD_LOGIC;
        reset : in std_logic;
        count : in unsigned(9 downto 0);
    --output--
        ram_en : out std_logic;
        ram_we : out std_logic;
        sig_uni_karnel : out std_logic;
        w_ram_addr : out unsigned(6 downto 0);
        calc_addr : out unsigned(6 downto 0)
    );
end gen_store_and_karnel_addr;

architecture Behavioral of gen_store_and_karnel_addr is

    --conv_addr--
    component conv_rom_and_ram_addr
        Port (
        --input--
            clk : in STD_LOGIC;
            count : in unsigned(9 downto 0);--168<256=2^8
            count_12 : in unsigned(3 downto 0);
        --output--
            w_ram_addr : out unsigned(6 downto 0);--112<128=2^7
            calc_addr : out unsigned(6 downto 0)--120<128=2^7
        );
    end component;
    
    --internal signal--
    constant count_bit : integer := 10;
    constant w_ram_addr_bit : integer := 7;
    constant calc_addr_bit : integer := 7;

    signal count_12 : unsigned(3 downto 0) := (others => '0');
    signal count_temp : unsigned(count_bit -1 downto 0) := (others => '0');
    signal sig_uni_karnel_temp : std_logic := '0';
begin

    --conv_addr--
    conv_addr : conv_rom_and_ram_addr
        port map (
        --input--
            clk => clk,
            count => count_temp,
            count_12 => count_12,
        --output--
            w_ram_addr => w_ram_addr,
            calc_addr => calc_addr
        );
        
    --generate ram/rom en/we--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset='1') then
                ram_en <= '1';
                ram_we <= '1';
            else
                if (to_integer(count_temp) = 48) then
                    ram_we <= '0';
                elsif (to_integer(count_temp) = 479) then
                    ram_we <= '1';
                    --ram_en <= '0'; --_1
                end if;
            end if;
        end if;
    end process;
    
    --function--
    --J[lړp3612counter:(if:count>47)--
    count_temp <= count;
    process(count_temp)
    begin
        if (47 < to_integer(count_temp) and to_integer(count_temp) <= 83) then
            count_12 <= to_unsigned(0, 4);
        elsif (83 < to_integer(count_temp) and to_integer(count_temp) <= 119) then
            count_12 <= to_unsigned(1, 4);
        elsif (119 < to_integer(count_temp) and to_integer(count_temp) <= 155) then
            count_12 <= to_unsigned(2, 4);
        elsif (155 < to_integer(count_temp) and to_integer(count_temp) <= 191) then
            count_12 <= to_unsigned(3, 4);
        elsif (191 < to_integer(count_temp) and to_integer(count_temp) <= 227) then
            count_12 <= to_unsigned(4, 4);
        elsif (227 < to_integer(count_temp) and to_integer(count_temp) <= 263) then
            count_12 <= to_unsigned(5, 4);
        elsif (263 < to_integer(count_temp) and to_integer(count_temp) <= 299) then
            count_12 <= to_unsigned(6, 4);
        elsif (299 < to_integer(count_temp) and to_integer(count_temp) <= 335) then
            count_12 <= to_unsigned(7, 4);
        elsif (335 < to_integer(count_temp) and to_integer(count_temp) <= 371) then
            count_12 <= to_unsigned(8, 4);
        elsif (371 < to_integer(count_temp) and to_integer(count_temp) <= 407) then
            count_12 <= to_unsigned(9, 4);
        elsif (407 < to_integer(count_temp) and to_integer(count_temp) <= 443) then
            count_12 <= to_unsigned(10, 4);
        elsif (443 < to_integer(count_temp) and to_integer(count_temp) <= 479) then
            count_12 <= to_unsigned(11, 4);
        else
            count_12 <= (others => '0');
        end if;
    end process;
    
    --generate sig_uni_karnel--
    --1w̃pfBOf[^ǂݏo--
    process(clk)
    begin
        if (clk'event and clk='1') then
            case to_integer(count_temp) is
                when 83 => sig_uni_karnel_temp <= '1';
                when 119 => sig_uni_karnel_temp <= '1';
                when 155 => sig_uni_karnel_temp <= '1';
                when 191 => sig_uni_karnel_temp <= '1';
                when 227 => sig_uni_karnel_temp <= '1';
                when 263 => sig_uni_karnel_temp <= '1';
                when 299 => sig_uni_karnel_temp <= '1';
                when 335 => sig_uni_karnel_temp <= '1';
                when 371 => sig_uni_karnel_temp <= '1';
                when 407 => sig_uni_karnel_temp <= '1';
                when 443 => sig_uni_karnel_temp <= '1';
                when 479 => sig_uni_karnel_temp <= '1';
                when others => sig_uni_karnel_temp <= '0';
            end case;
        end if;
    end process;
    
    sig_uni_karnel <= sig_uni_karnel_temp;

end Behavioral;
