----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/04 19:23:10
-- Design Name: 
-- Module Name: gen_w_addr - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity gen_w_addr is
    Port (
    --input--
        clk : in STD_LOGIC;
        reset_layer1 : in std_logic;
        reset_layer2 : in std_logic;
        reset_layer3 : in std_logic;
        reset_layer4 : in std_logic;
        reset_layer_affine : in std_logic;
        count_layer1 : in unsigned(9 downto 0);
        count_layer2 : in unsigned(11 downto 0);
        count_layer3 : in unsigned(11 downto 0);
        count_layer4 : in unsigned(11 downto 0);
        count_layer_affine : in unsigned(7 downto 0);
    --output--
        bias_rom_en : out std_logic;
        bias_addr : out unsigned(7 downto 0);
        w_rom_en : out unsigned(31 downto 0); --rom_en, 32ch
        w_addr : out unsigned(10 downto 0) --d݃f[^ő1092<2048=2^11
    );
end gen_w_addr;

architecture Behavioral of gen_w_addr is
    signal count12 : unsigned(3 downto 0) := (others => '0');
    signal w_addr_temp : unsigned(10 downto 0) := (others => '0');
begin

    --weight addr--
    process(clk)
    begin
        if (clk'event and clk= '1') then
            if (reset_layer1 = '0') then --layer1:weight read addr
                if  (to_integer(count_layer1) > 47 and to_integer(count_layer1) <= 83) then
                    w_addr_temp <= to_unsigned(to_integer(count_layer1)-48, w_addr'length);
                    for i in 0 to 31 loop
                        w_rom_en(i) <= '1';
                    end loop;
                else
                    w_addr_temp <= (others => '0');
                    for i in 0 to 31 loop
                        w_rom_en(i) <= '0';
                    end loop;
                end if;
            elsif (reset_layer2 = '0') then --layer2:weight read addr
                if (to_integer(count_layer2) < 3456) then
                    w_addr_temp <= to_unsigned(36 + to_integer(count_layer2) - 288 * to_integer(count12), w_addr'length);
                    for i in 0 to 31 loop
                        w_rom_en(i) <= '1';
                    end loop;
                else
                    w_rom_en <= (others => '0');
                end if;
            elsif (reset_layer3 = '0') then --layer3:weight read addr
                if (to_integer(count_layer3) < 3456) then
                    w_addr_temp <= to_unsigned(36 + 288 + to_integer(count_layer3) - 288 * to_integer(count12), w_addr'length);
                    for i in 0 to 31 loop
                        w_rom_en(i) <= '1';
                    end loop;
                end if;
            elsif (reset_layer4 = '0') then --layer3:weight read addr
                if (to_integer(count_layer4) < 3456) then
                    w_addr_temp <= to_unsigned(36 + 288 + 288 + to_integer(count_layer4) - 288 * to_integer(count12), w_addr'length);
                    for i in 0 to 31 loop
                        w_rom_en(i) <= '1';
                    end loop;
                end if;
            elsif (reset_layer_affine = '0') then --layer3:weight read addr
                if (to_integer(count_layer_affine) < 192) then
                    w_addr_temp <= to_unsigned(36 + 288 + 288 + 288 + to_integer(count_layer_affine), w_addr'length);
                    for i in 0 to 23 loop
                        w_rom_en(i) <= '1';
                    end loop;
                    for i in 24 to 31 loop
                        w_rom_en(i) <= '0';
                    end loop;
                end if;
            end if;
        end if;
    end process;
    w_addr <= w_addr_temp;
    
    --bias addr--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (reset_layer1 = '0') then
                if  (to_integer(count_layer1) > 47 and to_integer(count_layer1) <= 81) then
                    bias_addr <= to_unsigned(to_integer(count_layer1)-48, bias_addr'length);
                    bias_rom_en <= '1';
                else
                    bias_addr <= (others => '0');
                    bias_rom_en <= '0';
                end if;
            elsif (reset_layer2 = '0') then
                if (to_integer(w_addr_temp) > 290 and to_integer(w_addr_temp) <= 322) then
                    bias_rom_en <= '1';
                    bias_addr <= to_unsigned(32 + to_integer(w_addr_temp) - 291, bias_addr'length);
                else
                    bias_addr <= (others => '0');
                    bias_rom_en <= '0';
                end if;
            elsif (reset_layer3 = '0') then
                if (to_integer(w_addr_temp) > 326 and to_integer(w_addr_temp) <= 358) then
                    bias_rom_en <= '1';
                    bias_addr <= to_unsigned(64 + to_integer(w_addr_temp) - 327, bias_addr'length);
                else
                    bias_addr <= (others => '0');
                    bias_rom_en <= '0';
                end if;
            elsif (reset_layer4 = '0') then
                if (to_integer(w_addr_temp) > 614 and to_integer(w_addr_temp) <= 646) then
                    bias_rom_en <= '1';
                    bias_addr <= to_unsigned(96 + to_integer(w_addr_temp) - 615, bias_addr'length);
                else
                    bias_addr <= (others => '0');
                    bias_rom_en <= '0';
                end if;
            elsif (reset_layer_affine = '0') then
                if (to_integer(w_addr_temp) > 902 and to_integer(w_addr_temp) <= 914) then
                    bias_rom_en <= '1';
                    bias_addr <= to_unsigned(128 + to_integer(w_addr_temp) - 903, bias_addr'length);
                else
                    bias_addr <= (others => '0');
                    bias_rom_en <= '0';
                end if;
            end if;
        end if;
    end process;

    --count12--
    process(clk)
    begin
        if (clk'event and clk = '1') then
            if (reset_layer2 = '0') then
                case to_integer(count_layer2) is
                    when 0 => count12 <= to_unsigned(0, count12'length);
                    when 287 => count12 <= to_unsigned(1, count12'length);
                    when 575 => count12 <= to_unsigned(2, count12'length);
                    when 863 => count12 <= to_unsigned(3, count12'length);
                    when 1151 => count12 <= to_unsigned(4, count12'length);
                    when 1439 => count12 <= to_unsigned(5, count12'length);
                    when 1727 => count12 <= to_unsigned(6, count12'length);
                    when 2015 => count12 <= to_unsigned(7, count12'length);
                    when 2303 => count12 <= to_unsigned(8, count12'length);
                    when 2591 => count12 <= to_unsigned(9, count12'length);
                    when 2879 => count12 <= to_unsigned(10, count12'length);
                    when 3167 => count12 <= to_unsigned(11, count12'length);
                    when 3455 => count12 <= to_unsigned(0, count12'length);
                    when others => null;
                end case;
            elsif (reset_layer3 = '0') then
                case to_integer(count_layer3) is
                    when 0 => count12 <= to_unsigned(0, count12'length);
                    when 287 => count12 <= to_unsigned(1, count12'length);
                    when 575 => count12 <= to_unsigned(2, count12'length);
                    when 863 => count12 <= to_unsigned(3, count12'length);
                    when 1151 => count12 <= to_unsigned(4, count12'length);
                    when 1439 => count12 <= to_unsigned(5, count12'length);
                    when 1727 => count12 <= to_unsigned(6, count12'length);
                    when 2015 => count12 <= to_unsigned(7, count12'length);
                    when 2303 => count12 <= to_unsigned(8, count12'length);
                    when 2591 => count12 <= to_unsigned(9, count12'length);
                    when 2879 => count12 <= to_unsigned(10, count12'length);
                    when 3167 => count12 <= to_unsigned(11, count12'length);
                    when 3455 => count12 <= to_unsigned(0, count12'length);
                    when others => null;
                end case;
            elsif (reset_layer4 = '0') then
                case to_integer(count_layer4) is
                    when 0 => count12 <= to_unsigned(0, count12'length);
                    when 287 => count12 <= to_unsigned(1, count12'length);
                    when 575 => count12 <= to_unsigned(2, count12'length);
                    when 863 => count12 <= to_unsigned(3, count12'length);
                    when 1151 => count12 <= to_unsigned(4, count12'length);
                    when 1439 => count12 <= to_unsigned(5, count12'length);
                    when 1727 => count12 <= to_unsigned(6, count12'length);
                    when 2015 => count12 <= to_unsigned(7, count12'length);
                    when 2303 => count12 <= to_unsigned(8, count12'length);
                    when 2591 => count12 <= to_unsigned(9, count12'length);
                    when 2879 => count12 <= to_unsigned(10, count12'length);
                    when 3167 => count12 <= to_unsigned(11, count12'length);
                    when 3455 => count12 <= to_unsigned(0, count12'length);
                    when others => null;
                end case;
            else
                count12 <= (others => '0');
            end if;
        end if;
    end process;
end Behavioral;
