----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/17 10:33:14
-- Design Name: 
-- Module Name: padding_data_re - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity padding_data_re is
    generic (
        data_int : integer;
        data_dec : integer
    );
    Port (
    --input--
        clk : in STD_LOGIC;
        reset : in std_logic;
        count : in unsigned(9 downto 0);
        in_data : in signed(data_int+data_dec -1 downto 0);
    --output--
        sig_36_data_out : out std_logic;
        uni_data : out signed((data_int+data_dec)*36 -1 downto 0)
    );
end padding_data_re;

architecture Behavioral of padding_data_re is

    --AhX--
    component gen_store_and_karnel_addr
        Port (
        --input--
            clk : in STD_LOGIC;
            reset : in std_logic;
            count : in unsigned(9 downto 0);
        --output-- 
            ram_en : out std_logic;
            ram_we : out std_logic;
            sig_uni_karnel : out std_logic;
            w_ram_addr : out unsigned(6 downto 0);
            calc_addr : out unsigned(6 downto 0)
        );
    end component;
    
    --[peBOf[^--
    component padding_ram
        generic (
            data_bit : integer;
            addr_bit : integer
        );
        Port ( 
        --input--
            clk : in STD_LOGIC;
            ena : in std_logic;
            wea : in std_logic;
            addra : in unsigned(addr_bit -1 downto 0);
            addrb : in unsigned(addr_bit -1 downto 0);
            dina : in signed(data_bit -1 downto 0);
        --output--
            doutb : out signed(data_bit -1 downto 0)
        );
    end component;
    
    --internal signal--
    constant data_len : integer := data_int+data_dec;
    constant ram_addr_bit : integer := 7;
    constant count_bit : integer := 9;
    
    signal ram_en : std_logic := '0';
    signal ram_we : std_logic := '0';
    signal w_ram_addr : unsigned(ram_addr_bit -1 downto 0) := (others => '0');
    signal calc_addr : unsigned(ram_addr_bit -1 downto 0) := (others => '0');
    signal ram_data_out : signed(data_len -1 downto 0) := (others => '0');
    
    --36f[^ꊇp--
    signal uni_data_temp : signed(data_len*36 -1 downto 0) := (others => '0');
    signal count36 : unsigned(5 downto 0) := (others => '0');
    signal ram_we_delay_1, ram_we_delay_2 : std_logic := '0';
    signal sig_data_out : std_logic := '0'; --36count1clockx点ȂƍŌ̃f[^܂ĂȂ
begin
    --[peBOf[^ram--
    data : padding_ram
        generic map (
            data_bit => data_len,
            addr_bit => ram_addr_bit
        )
        port map (
        --input--
            clk => clk,
            ena => ram_en,
            wea => ram_we,
            addra => w_ram_addr,
            addrb => calc_addr,
            dina => in_data,
        --output--
            doutb => ram_data_out
        );
    
    gen_addr : gen_store_and_karnel_addr
        port map (
        --input--
            clk => clk,
            reset => reset,
            count => count,
        --output--,
            ram_en => ram_en,
            ram_we => ram_we,
            sig_uni_karnel => sig_36_data_out,--dݏo̓^C~OɎgp
            w_ram_addr => w_ram_addr,
            calc_addr => calc_addr
        );


    --function--
    
    --36f[^ꊇM--
    --36 counter:ram_we0ɂȂ1 clockォJEgJn--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (to_integer(count36) = 35) then
                count36 <= (others => '0');
                sig_data_out <= '1';
            elsif (ram_we_delay_1 = '1') then
                count36 <= (others => '0');
                sig_data_out <= '0';
            else
                count36 <= count36 + to_unsigned(1, 4);
                sig_data_out <= '0';
            end if;
        end if;
    end process;
    
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (ram_we_delay_2 = '1') then
                uni_data_temp <= (others => '0');
            else
--                uni_data_temp(uni_data_temp'length- to_integer(count36)*data_len -1 downto uni_data_temp'length- (to_integer(count36)+1)*data_len) <= ram_data_out;
                uni_data_temp(uni_data_temp'length-35*data_len -1 downto 0) <= ram_data_out;
                uni_data_temp(uni_data_temp'length -1 downto data_len) <= uni_data_temp(uni_data_temp'length-data_len -1 downto 0);
            end if;
        end if;
    end process;
    
    --DFF--
    process(clk)
    begin
        if (clk'event and clk='1') then
            ram_we_delay_1 <= ram_we;
            ram_we_delay_2 <= ram_we_delay_1;
        end if;
    end process;
    
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (sig_data_out = '1') then
                uni_data <= uni_data_temp;
            else
                uni_data <= (others => '0');
            end if;
        end if;
    end process;
    

end Behavioral;