----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2021/12/24 13:26:21
-- Design Name: 
-- Module Name: padding_ram - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity padding_ram is
    generic (
        data_bit : integer;
        addr_bit : integer
    );
    Port ( 
    --input--
        clk : in STD_LOGIC;
        ena : in std_logic;
        wea : in std_logic;
        addra : in unsigned(addr_bit -1 downto 0);
        addrb : in unsigned(addr_bit -1 downto 0);
        dina : in signed(data_bit -1 downto 0);
    --output--
        doutb : out signed(data_bit -1 downto 0)
    );
end padding_ram;

architecture Behavioral of padding_ram is
    type mem_type is array (0 to 256) of signed(data_bit -1 downto 0);
    signal mem : mem_type := (others => (others => '0'));
    attribute ramstyle : string;
    attribute ramstyle of mem : signal is "block"; 

begin
    --write--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (wea = '1') then
                mem(to_integer(addra)) <= dina;
            end if;
        end if;
    end process;
    
    --read--
    process(clk)
    begin
        if (clk'event and clk='1') then
            if (ena = '1') then
                doutb <= mem(to_integer(addrb));
            end if;
        end if;
    end process;


end Behavioral;
