----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2022/01/10 20:21:23
-- Design Name: 
-- Module Name: w_rom - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;
use std.textio.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity w_rom is
    generic (
      file_name : string;
      data_len : integer;
      addr_bit : integer
    );
    Port (
    --input--
    clk : in STD_LOGIC;
    ena : in std_logic;
    addr : in unsigned(addr_bit -1 downto 0);
    --output--
    dout : out signed(data_len -1 downto 0)
    );
end w_rom;

architecture Behavioral of w_rom is

    --internal signal--
    constant rom_depth : integer := 1092;

    --for ram--
    type rom_type is array(0 to rom_depth -1) of signed(data_len -1 downto 0);
    

    --read text data and return data as rom_type--
    impure function store_rom_data (file_name : string) return rom_type is
        file text_file : text is in file_name;
        variable text_line : line;
        variable rom_content : rom_type;
        variable line_bit : bit_vector(23 downto 0);--variableȂ̂łǂꂾmۂ邩w
    begin
        --file_open(text_file, file_name, read_mode);--t@Cǂݎ胂[hŊJ
        
        for i in 0 to rom_depth -1 loop --瑤ŉsǂ݂w肵Ă̂œendƂ͕KvȂ
            readline(text_file, text_line); --impureȂfileJȂ炵F1sǂ݂lineϐɂ܂
            read(text_line, line_bit); --lineϐϊ
            rom_content(i) := signed(to_stdlogicvector(line_bit(22 downto 6)));--signedɕϊ
        end loop;
        
        --file_close(text_file);--t@C
    
        return rom_content;
    end function;
    
    --rom--
    signal rom_temp : rom_type := store_rom_data(file_name);
    attribute RAM_STYLE : string;--block ram D抄蓖
    attribute RAM_STYLE of rom_temp : signal is "block";
    
    signal data_i : signed(data_len -1 downto 0) := (others => '0');
    
    
begin
    process(clk)
    begin
        if (clk'event and clk='1') then
            if(ena = '1') then
                data_i <= rom_temp(to_integer(addr));
            else
                data_i <= (others => '0');
            end if;
        end if;
    end process;
    
    dout <= data_i;


end Behavioral;